{ 021214a4.pas                                                              }
{ 2002-12-14 programmeerimisvistluse algajate 4. lesande lahendus         }
{    BITIMAATRIKS                                                           }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'BMAT.SIS';
   valf = 'BMAT.VAL';
   n = 8;                                           { maatriksi kljepikkus }

type
   mat = array [1..n, 1..n] of integer;                          { maatriks }

{ loeb failist reaesitusega antud maatriksi }
procedure sis_mat (var f : text; var m : mat);
var i, j, r : integer;
begin
   for i := 1 to n do begin
      readln(f, r);                                 { loeme he rea esituse }
      { lahutame reaesituse bittideks }
      for j := n downto 1 do begin             { lahutame paremalt vasakule }
         m[i, j] := r and 1;                 { eraldame parempoolseima biti }
         r := r shr 1;                      { ja nihutame selle reast vlja }
      end;
      { kontroll: nd peab kehtima: r = 0 }
   end;
end;

{ kirjutab faili maatriksi reaesituse }
procedure val_mat (var f : text; var m : mat);
var i, j, r : integer;
begin
   for i := 1 to n do begin
      r := 0;                                  { alguses on rea esitus thi }
      { moodustame bittidest rea esituse }
      for j := 1 to n do begin             { kokku paneme vasakult paremale }
         r := r shl 1;               { nihutame olemasolevad bitid vasakule }
         r := r + m[i, j];            { ja lisame uue biti parempoolseimaks }
      end;
      writeln(f, r);                           { vljastame he rea esituse }
   end;
end;

{ transponeerib maartiksi }
procedure trn_mat (var m : mat);
var i, j, x : integer;
begin
   for i := 1 to n do
      for j := i + 1 to n do begin
         x := m[i, j]; m[i, j] := m[j, i]; m[j, i] := x;
      end;
end;

var
   f : text;                                           { sisend/vljundfail }
   m : mat;                                                      { maatriks }

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   sis_mat(f, m);
   close(f);

   { arvutame vastuse }
   trn_mat(m);

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   val_mat(f, m);
   close(f);
end.
