{ 021214e3.pas                                                              }
{ 2002-12-14 programmeerimisvistluse edasijudnute 3. lesande lahendus    }
{    KODEERITUD LIITMINE                                                    }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'LIIT.SIS';
   valf = 'LIIT.VAL';
   maxr = 3;                                         { ridade arv avaldises }
   maxp = 10;                                     { maksimaalne arvu pikkus }
   tuhi = ' ';                                        { thi vli avaldises }
   pole = -1;                                { the vrtus pole veel teada }

var
   f : text;                                           { sisend/vljundfail }
   a : array [1..maxr, 0..maxp] of char;                          { avaldis }
   y : array [0..maxp] of integer;                              { lekanded }
   t : array ['A'..'Z'] of integer;                     { thtede vrtused }
   n : array ['A'..'Z'] of boolean;               { kas tht vib olla null }
   v : array [0..9] of boolean;         { kas number (vrtus) on veel vaba }

{ seab algseisu }
procedure algseis;
var i, j : integer; c : char;
begin
   for i := 1 to maxr do
      for j := 0 to maxp do
         a[i, j] := tuhi;
   for j := 0 to maxp do
      y[j] := 0;
   for c := 'A' to 'Z' do begin
      t[c] := pole;
      n[c] := true;
   end;
   for i := 0 to 9 do
      v[i] := true;
end;

{ loeb failist sisendandmed }
procedure sisend (var f : text);
var i, j : integer; s : string;
begin
   for i := 1 to maxr do begin
      readln(f, s);
      for j := 1 to length(s) do
         a[i, j + (maxp - length(s))] := s[j];
      if length(s) > 1 then
         n[s[1]] := false;
   end;
end;

{ vljastab tulemuse faili }
procedure tulemus (var f : text);
var i, j : integer;
begin
   for i := 1 to maxr do begin
      for j := 1 to maxp do
         if a[i, j] <> ' ' then
            write(f, t[a[i, j]]);
      writeln(f);
   end;
end;

{ pab jtkata lahendust kohast r, v }
function otsi (r, p : integer) : boolean;
var i, k : integer;
begin
   if a[r, p] = tuhi then begin                { kui avaldises on thi koht }
      if r = maxr then                         { kui thi koht on summareal }
         if y[p] = 0 then                            { kui lekanne on null }
            otsi := true                         { siis teatame lahendusest }
         else                                      { kui lekanne pole null }
            otsi := false                         { siis teatame vastuolust }
      else                                { kui thi koht on liidetava real }
         otsi := otsi(r + 1, p);            { siis jtkame jrgmiselt realt }
      exit;
   end;

   { nd teame, et vaadeldav koht avaldises ei ole thi }
   if r = maxr then begin                             { kui oleme summareal }
      { arvutame veerusumma }
      k := y[p];                        { eelmisest veerust tulnud lekanne }
      for i := 1 to maxr - 1 do                     { kik liidetavate read }
         if a[i, p] <> tuhi then                       { kui pole thi koht }
            k := k + t[a[i, p]];                { siis vtame the vrtuse }
      y[p - 1] := k div 10;                 { kmnelised lhevad lekandeks }
      k := k mod 10;                          { helised jvad siia veergu }

      if t[a[r, p]] <> pole then begin     { kui summathe vrtus on teada }
         if t[a[r, p]] = k then                 { ja see sobib meie summaga }
            otsi := otsi(1, p - 1)         { siis jtkame jrmisest veerust }
         else                                { kui see ei sobi meie summaga }
            otsi := false;                        { siis teatame vastuolust }
         exit;
      end;

      { nd teame, et summathel pole veel vrtust }
      if not v[k] then begin                { kui vajalik vrtus pole vaba }
         otsi := false;                           { siis teatame vastuolust }
         exit;
      end;

      if not n[a[r, p]] then               { kui summatht ei vi null olla }
         if k = 0 then begin                    { aga tegelik summa on null }
            otsi := false;                        { siis teatame vastuolust }
            exit;
         end;

      { nd teame, et uus vrtus sobib summathele }
      t[a[r, p]] := k;                      { omistame vrtuse summathele }
      v[k] := false;                      { nd see vrtus pole enam vaba }
      if otsi(1, p - 1) then begin             { jtkame jrgmisest veerust }
         otsi := true;        { kui jtkamine nnestus, teatame lahendusest }
         exit;
      end;
                                                { kui jtkamine ebannestus }
      t[a[r, p]] := pole;                     { vtame summathelt vrtuse }
      v[k] := true;                                { laseme vrtuse vabaks }
      otsi := false;                                   { teatame vastuolust }
      exit;
   end;

   { nd teame, et oleme liidetava real }
   if t[a[r, p]] <> pole then begin      { kui sellel thel juba on vrtus }
      otsi := otsi(r + 1, p);               { siis jtkame jrgmiselt realt }
      exit;
   end;

   { nd teame, et see tht on veel vaba }
   if n[a[r, p]] then                         { kui see tht vib olla null }
      i := 0                             { siis alustame proovimist nullist }
   else                                     { kui see tht ei vi olla null }
      i := 1;                              { siis alustame proovimist hest }
   for k := i to 9 do                     { proovime kiki lubatud variante }
      if v[k] then begin                          { kui see vrtus on vaba }
         t[a[r, p]] := k;                        { omistame vrtuse thele }
         v[k] := false;                   { nd see vrtus pole enam vaba }
         if otsi(r + 1, p) then begin            { jtkame jrgmiselt realt }
            otsi := true;     { kui jtkamine nnestus, teatame lahendusest }
            exit;
         end;
         { kui jtkamine ebannestus }
         t[a[r, p]] := pole;                       { vtame thelt vrtuse }
         v[k] := true;                             { laseme vrtuse vabaks }
      end;
                                     { kui kski lubatud variant ei sobinud }
   otsi := false;                                      { teatame vastuolust }
   exit;
end;

begin
   { seame algseisu ja loeme sisendandmed }
   algseis;
   assign(f, sisf); reset(f);
   sisend(f);
   close(f);

   { leiame ja vljastame vastuse }
   assign(f, valf); rewrite(f);
   if otsi(1, maxp) then
      tulemus(f)
   else
      writeln(f, 'Vigane test: lahendust pole');
   close(f);
end.
