{ kontroll.pas                                                              }
{ 2002-12-14 programmeerimisvistluse edasijudnute 3. lesande tester      }
{    KODEERITUD LIITMINE                                                    }
{ Ahto Truu                                                                 }

{$I+}

const
   maxr = 3;
   maxp = 10;
const
   num : array ['0'..'9'] of integer = (0, 1, 2, 3, 4, 5, 6, 7, 8, 9);

var
   f : text;
   s1, s2 : array [1..maxr] of string;
   ss1, ss2 : string;
   i, j, k : integer;
   c : char;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   for i := 1 to maxr do
      readln(f, s1[i]);
   close(f);

   { loeme vljundandmed }
   assign(f, paramstr(2)); reset(f);
   for i := 1 to maxr do
      readln(f, s2[i]);
   close(f);

   { kontrollime reapikkused }
   for i := 1 to maxr do
      if length(s1[i]) <> length(s2[i]) then begin
         writeln('Vale reapikkus');
         halt(1);
      end;

   { kontrollime, et ainult numbrid }
   for i := 1 to maxr do
      for j := 1 to length(s2[i]) do
         if not (s2[i][j] in ['0'..'9']) then begin
            writeln('Lubamatu smbol');
            halt(1);
         end;

   { kontrollime algusnulle }
   for i := 1 to maxr do
      if length(s2[i]) > 1 then
         if s2[i][1] = '0' then begin
            writeln('Algusnull');
            halt(1);
         end;

   { kontrollime ks-hesust }
   ss1 := ''; ss2 := '';
   for i := 1 to 3 do begin
      ss1 := ss1 + s1[i]; ss2 := ss2 + s2[i];
   end;
   for i := 1 to length(ss1) do
      for j := i to length(ss1) do
         if (ss1[i] = ss1[j]) <> (ss2[i] = ss2[j]) then begin
            writeln('Vastavus pole ks-hene: ', ss1[i], ss1[j], ss2[i], ss2[j]);
            halt(1);
         end;

   { kontrollime summat }
   k := 0;
   for j := 0 to maxp do begin
      for i := 1 to maxr - 1 do
         if j < length(s2[i]) then
            k := k + num[s2[i][length(s2[i]) - j]];
      if j < length(s2[maxr]) then begin
         if k mod 10 <> num[s2[maxr][length(s2[maxr]) - j]] then begin
            writeln('Summa ei klapi: ', j);
            halt(1);
         end;
      end else if k > 0 then begin
         writeln('Summa ei klapi');
         halt(1);
      end;
      k := k div 10;
   end;

   writeln('OK');
end.
