{ 021214e1.pas                                                              }
{ 2002-12-14 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{    ORIENTEERUMISVISTLUS                                                  }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'ORIENT.SIS';
   valf = 'ORIENT.VAL';
   maxkoh = 20;             { maksimaalne kohustuslike kontrollpunktide arv }
   maxlab = 50;                  { maksimaalne lbitud kontrollpunktide arv }

var
   f : text;                                           { sisend/vljundfail }
   koh : array [1..maxkoh+1] of integer;             { kohstuslikud punktid }
   lab : array [1..maxlab] of integer;                    { lbitud punktid }
   nkoh, nlab : integer;
   ikoh, ilab : integer;
   ok : boolean;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, nkoh, nlab);
   for ikoh := 1 to nkoh do
      read(f, koh[ikoh]);
   readln(f);
   for ilab := 1 to nlab do
      read(f, lab[ilab]);
   readln(f);
   close(f);

   ok := true;
   { kontrollime, et vajalikud punktid on lbitud }
   koh[nkoh + 1] := -1;         { lputunnus, et ei lheks massiivist vlja }
   ikoh := 1;                 { alustame esimese vajaliku punkti ostimisest }
   for ilab := 1 to nlab do             { vaatame lbi kik lbitud punktid }
      if lab[ilab] = koh[ikoh] then              { kui vajalik punkt leitud }
         ikoh := ikoh + 1;                    { jtkame jrgmise vajalikuga }
   if ikoh <> nkoh + 1 then                    { kui kiki vajalikke ei ole }
      ok := false;                                           { siis on viga }
   { kontrollime, et algus on stardis ja lpp finiis }
   if (lab[1] <> koh[1]) or (lab[nlab] <> koh[nkoh]) then
      ok := false;
   { kontrollime, et vahepeal ei kida stardis ega finiis }
   for ilab := 2 to nlab - 1 do
      if (lab[ilab] = koh[1]) or (lab[ilab] = koh[nkoh]) then
         ok := false;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   if ok then
      writeln(f, 'JAH')
   else
      writeln(f, 'EI');
   close(f);
end.
